{% extends 'base.html' %}

{% block content %}
{% autoescape false %}

{% set medias = content.getMedias() %}
<div class="fr-col-12">
    <div class="fr-grid-row">
        <div class="fr-col-12 fr-col-lg-2">
            {% include 'content/side-nav.html' %}
        </div>

        <div class="fr-col-12 fr-col-lg-10">
            <section class="gn-main-content">
                <header class="fr-grid-row fr-grid-row--middle">
                    <h1 class="fr-h3">
                        {% if content is not null %}
                        &Eacute;diter contenu - {{ content.title }}
                        {% else %}
                        Nouveau contenu
                        {% endif %}
                    </h1>
                </header>
                <div class="gn-content--spaced gn-cards-list gn-tabs">
                    {% if content is not null %}
                        {% set action = 'update' %}
                    {% else %}
                        {% set action = 'add' %}
                    {% endif %}
                    <form method="post" id="content-form" action="{{ domain }}/action/{{ action }}/content" class="needs-validation" enctype="multipart/form-data" novalidate>
                        <input type="hidden" name="current-url" value="{{ currentUrl }}" />
                        <input type="hidden" name="{{ csrf.keys.name }}" value="{{ csrf.name }}" />
                        <input type="hidden" name="{{ csrf.keys.value }}" value="{{ csrf.value }}" />
                        <input type="hidden" name="content-id" value="{{ content.id }}" />

                        <div class="fr-input-group">
                            <div class="fr-grid-row fr-grid-row--gutters">
                                <div class="fr-col">
                                    <label class="fr-label">S&eacute;lectionnez vos canaux de communication</label>
                                    {% set channelsState = [] %}
                                    {% set selectedChannels = [] %}
                                    {% set communications = content.communications %}
                                    {% for communication in communications %}
                                        {% if communication.channel == 'EMAIL' %}
                                            {% set channelsState = channelsState|merge({'email' : 'checked'}) %}
                                        {% elseif communication.channel == 'SMS' %}
                                            {% set channelsState = channelsState|merge({'sms' : 'checked'}) %}
                                        {# {% elseif communication.channel == 'FACEBOOK' %}
                                            {% set channelsState = channelsState|merge({'facebook' : 'checked'}) %}
                                        {% elseif communication.channel == 'INSTAGRAM' %}
                                            {% set channelsState = channelsState|merge({'instagram' : 'checked'}) %} #}
                                        {% elseif communication.channel == 'WEBSITE' %}
                                            {% set channelsState = channelsState|merge({'website' : 'checked'}) %}
                                        {% elseif communication.channel == 'CHANNEL' %}
                                            {% set selectedChannels = selectedChannels|merge([communication.organisationChannel.id]) %}
                                        {% endif %}
                                    {% endfor %}

                                    <fieldset class="gn-styled-checkboxes">
                                        <div>
                                            <input type="checkbox" id="content-channel-email" name="content-channel[]" value="EMAIL" {{ channelsState['email'] }} />
                                            <label for="content-channel-email">
                                                <span class="gn-styled-checkboxes__text">Par EMAIL</span>
                                                <span class="fr-icon-mail-line" aria-hidden="true" title="Par email"></span>
                                            </label>
                                        </div>
                                        <div>
                                            <input type="checkbox" id="content-channel-sms" name="content-channel[]" value="SMS" {{ channelsState['sms'] }} />
                                            <label for="content-channel-sms">
                                                <span class="gn-styled-checkboxes__text">Par SMS</span>
                                                <span class="fr-icon-message-2-line" aria-hidden="true" title="Par SMS"></span>
                                            </label>
                                        </div>
                                        <div>
                                            <input type="checkbox" id="content-channel-website" name="content-channel[]" value="WEBSITE" {{ channelsState['website'] }} />
                                            <label for="content-channel-website">
                                                <span class="gn-styled-checkboxes__text">Site Internet</span>
                                                <span class="fr-icon-window-fill" aria-hidden="true" title="Site Internet"></span>
                                            </label>
                                        </div>

                                        {% for channel in organization.activeChannels %}
                                            <div>
                                                <input type="checkbox" id="content-channel-{{ channel.id }}" name="content-channel[]" {{ channel.id in selectedChannels ? 'checked' : '' }} value="CHANNEL-{{ channel.id }}" />
                                                <label for="content-channel-{{ channel.id }}">
                                                    <span class="gn-styled-checkboxes__text">{{ channel.channelName }}</span>
                                                    <span class="fr-icon-{{ channel|channelIcon }}" aria-hidden="true" title="{{ channel.channelName }}"></span>
                                                </label>
                                            </div>
                                        {% endfor %}

                                    </fieldset>
                                </div>
                                <div class="fr-col">
                                    <label class="fr-label">Priorit&eacute;</label>
                                    <fieldset class="gn-styled-radios gn-styled-stars">
                                        <input class="star star-4" id="star-4" type="radio" name="content-priority" value="4" {% if content is not null and content.priority==4 %}checked{% endif %} />
                                        <label class="star star-4" for="star-4">
                                            <span class="fr-icon-star-fill" aria-hidden="true" title="Priorit&eacute; 4"></span>
                                        </label>
                                        <input class="star star-3" id="star-3" type="radio" name="content-priority" value="3" {% if content is not null and content.priority==3 %}checked{% endif %} />
                                        <label class="star star-3" for="star-3">
                                            <span class="fr-icon-star-fill" aria-hidden="true" title="Priorit&eacute; 3"></span>
                                        </label>
                                        <input class="star star-2" id="star-2" type="radio" name="content-priority" value="2" {% if content is not null and content.priority==2 %}checked{% endif %} />
                                        <label class="star star-2" for="star-2">
                                            <span class="fr-icon-star-fill" aria-hidden="true" title="Priorit&eacute; 2"></span>
                                        </label>
                                        <input class="star star-1" id="star-1" type="radio" name="content-priority" value="1" {% if content is not null and content.priority==1 %}checked{% endif %} />
                                        <label class="star star-1" for="star-1">
                                            <span class="fr-icon-star-fill" aria-hidden="true" title="Priorit&eacute; 1"></span>
                                        </label>
                                    </fieldset>
                                </div>
                            </div>

                            <br />
                        </div>

                        <div class="fr-input-group">
                            <label class="fr-label" for="content-title">Titre / objet / sujet du contenu</label>
                            <input class="fr-input" type="text" id="content-title" name="content-title" value="{{ content.title }}" required />
                            <p id="content-title-input-error" class="fr-error-text">Veuillez saisir un titre.</p>
                        </div>

                        <div class="fr-input-group">
                            <label class="fr-label" for="content-text">Texte / description du contenu</label>
                            <textarea class="fr-input" type="color" id="content-text" name="content-text"
                                required>{{ content.text }}</textarea>
                            <p id="content-text-input-error" class="fr-error-text">Veuillez saisir du texte au contenu.</p>
                        </div>

                        <div class="fr-grid-row fr-grid-row--gutters fr-grid-row--middle fr-mb-3w">
                            <div class="fr-upload-group fr-col-6">
                                <label class="fr-label" for="content-illustration">Image d'illustration

                                    <span class="fr-hint-text">{{ fileUploadHintText }}
                                        <br><strong>
                                            {% if content is not null and content.illustration|length %}
                                                Si une illustration est d&eacute;ja existante, elle sera supprim&eacute;e et remplac&eacute;e par la nouvelle image
                                            {% else %}
                                                Vous pouvez ajouter une image d'illustration pour votre contenu
                                            {% endif %}.
                                        </strong>
                                    </span>
                                </label>
                                <input class="fr-upload" type="file" id="content-illustration" name="content-illustration" accept="{{ fileUploadAccept }}" value="{{ content.illustration.name }}">
                                <p id="content-illustration-input-error" class="fr-error-text">Format de fichier non support&eacute;</p>
                            </div>
                            <div class="fr-col-6 text-center">
                                {% if content is not null and content.illustration|length %}
                                    <img class="content-illustration" width="auto" src="{{ content.illustration.url }}" alt="{{ content.title }}" title="{{ content.title }}" style="max-height:200px;" />
                                {% endif %}
                            </div>
                        </div>

                        <div class="fr-input-group fr-grid-row fr-grid-row--gutters">
                            <div class="fr-col-12" id="drag-and-drop-messages"></div>
                            <div class="fr-col-5">
                                <div id="drag-and-drop-zone" class="dm-uploader gn-uploader">
                                    <div class="gn-uploader-content">
                                        <span class="fr-icon-file-download-fill fr-icon--lg"
                                            aria-hidden="true"></span>
                                        <h2>Glissez/d&eacute;poser votre m&eacute;dia ici</h2>
                                        <small>Taille maximale par fichier : <span class="gnUploaderMaxFileSize"></span>.<br>Formats support&eacute;s : <span class="gnUploaderAllowerFormats"></span>.</small>
                                        <p><span>ou</span></p>
                                        <div>
                                            <div class="gn-uploader-button">
                                                <label class="fr-btn fr-icon-download-line fr-btn--icon-left"
                                                    role="button" for="content-new-files"
                                                    title="Importer un m&eacute;dia">Importer un m&eacute;dia
                                                <input id="content-new-files" name="content-new-files" type="file" title='Importer un m&eacute;dia' /></label>

                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="fr-col-7">
                                <div class="card h-100">
                                    <div class="card-header">Liste des fichiers t&eacute;l&eacute;vers&eacute;s</div>
                                    <ul class="list-unstyled p-2 d-flex flex-column col" id="files">
                                        <li class="text-muted text-center empty">Aucun fichier t&eacute;l&eacute;charg&eacute;.</li>
                                    </ul>
                                </div>
                            </div>
                        </div>

                        {% macro media_line(medium) %}
                            <input type="checkbox" id="delete-media-{{ medium.id }}" name="delete-media[{{ medium.id }}]">
                            <li class="fr-grid-row fr-grid-row--middle" id="medium-line-{{ medium.id }}">
                                <div class="fr-col-11 media-line fr-m-0">
                                    <div class="fr-grid-row fr-grid-row--gutters fr-grid-row--middle">
                                        <div class="fr-col-5 has-ellipsis">
                                            {{ medium.name }}
                                            <span class="mime {{ medium.extension }}">
                                                {{ medium.mimeType }} - {{ medium.size }}
                                            </span>
                                        </div>
                                        <div class="fr-col-7"><textarea class="w-100" name="edit-media[{{ medium.id }}]">{{ medium.description }}</textarea></div>
                                    </div>
                                </div>
                                <div class="fr-col-1 media-action">
                                    <label class="fr-btn fr-btn--sm fr-icon-eye-fill viewMedia" data-url="{{ medium.url }}" role="button" for="view-media-{{ medium.id }}" title="Consulter ce m&eacute;dia">Consulter</label>
                                    <label class="fr-btn fr-btn--sm fr-icon-arrow-go-back-fill undoDeleteMedia" role="button" for="delete-media-{{ medium.id }}" title="Annuler la suppression de ce m&eacute;dia">Annuler la suppression</label>
                                    <label class="fr-btn fr-btn--sm fr-icon-delete-fill deleteMedia" role="button" for="delete-media-{{ medium.id }}" title="Supprimer ce m&eacute;dia">Supprimer</label>
                                </div>
                            </li>
                        {% endmacro %}

                        {% if medias.count %}
                            <div class="fr-input-group">
                                <div class="card h-100">
                                    <div class="card-header">Liste des fichiers associ&eacute;s &agrave; ce contenu</div>
                                    <ul class=" content-medias list-unstyled p-2 d-flex flex-column col" id="files">
                                        {% for medium in medias %}
                                            {{ _self.media_line(medium) }}
                                        {% endfor %}
                                    </ul>
                                </div>
                            </div>
                        {% endif %}
                        <div class="fr-input-group">
                            <div class="fr-grid-row fr-grid-row--gutters">
                                <div class="fr-col">
                                    <div class="fr-select-group">
                                        <label class="fr-label" for="content-category">Cat&eacute;gorie</label>
                                        <select class="fr-select" id="content-category" name="content-category" required>
                                            <option value="" selected disabled hidden>Veuillez s&eacute;lectionner une cat&eacute;gorie</option>
                                            {% if categories|length > 0 %}
                                                {% for category in categories %}
                                                    {% set selected = '' %}
                                                    {% if content is not null and content.category.id == category.id %}
                                                        {% set selected = 'selected' %}
                                                    {% endif %}
                                                    <option value="{{ category.id }}" {{ selected }}>{{ category.name }}</option>
                                                {% endfor %}
                                            {% else %}
                                                <option value="">Aucune cat&eacute;gorie, veuillez en cr&eacute;er une...</option>
                                            {% endif %}
                                        </select>
                                        <p id="content-category-input-error" class="fr-error-text">Veuillez s&eacute;lectionner une cat&eacute;gorie.</p>
                                    </div>
                                </div>
                                <div class="fr-col">
                                    <div class="fr-select-group">
                                        <label class="fr-label" for="content-distributionList">Liste de diffusion</label>
                                        <select class="fr-select" id="content-distributionList" name="content-distributionList">
                                            <option value="" selected disabled hidden>Veuillez s&eacute;lectionner une liste de diffusion</option>
                                            {% if distributionLists|length > 0 %}
                                                {% for distribution in distributionLists %}
                                                    {% set selected = '' %}
                                                    {% if distribution.id == content.distributionList.id %}
                                                        {% set selected = 'selected' %}
                                                    {% endif %}
                                                    <option value="{{ distribution.id }}" {{ selected }}>{{ distribution.title }}</option>
                                                {% endfor %}
                                            {% else %}
                                                <option value="">Aucune liste de diffusion, veuillez en cr&eacute;er une...</option>
                                            {% endif %}
                                        </select>
                                        <p id="content-distributionList-input-error" class="fr-error-text">Veuillez s&eacute;lectionner une liste de diffusion.</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                        {% if content is not null and content.deadline %}
                            {% set date = content.deadline|date('Y-m-d') %}
                            {% set time = content.deadline|date('H:i') %}
                        {% endif %}
                        <div class="fr-input-group">
                            <div class="fr-grid-row fr-grid-row--gutters">
                                <div class="fr-col fr-col-6">
                                    <div class="fr-grid-row fr-grid-row--gutters">
                                        <div class="fr-col">
                                            <label class="fr-label" for="content-send-date">Date d'envoi</label>
                                            <input class="fr-input" type="date" id="content-send-date" name="content-send-date" value="{{ date }}" />
                                        </div>
                                        <div class="fr-col">
                                            <label class="fr-label" for="content-send-time">Horaire d'envoi</label>
                                            <input class="fr-input" type="time" id="content-send-time" name="content-send-time" value="{{ time }}" />
                                        </div>
                                    </div>
                                </div>
                                <div class="fr-col fr-col-2 fr-mt-5w">
                                    <div class="fr-checkbox-group">
                                        <input type="checkbox" id="content-ready" name="content-ready" {% if content is not null and content.status=='TO_PUBLISH' or content.status=='PUBLISHING' %}checked{% endif %} />
                                        <label class="fr-label" for="content-ready">Pr&ecirc;t &agrave; publier</label>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <div class="fr-grid-row fr-grid-row--gutters">
                            <div class="fr-col fr-col-6">
                                <ul class="fr-btns-group fr-btns-group--md fr-btns-group--inline-lg fr-btns-group--icon-left">
                                    <li>
                                        <button type="submit" class="fr-btn fr-icon-check-line" id="save-content">
                                            Enregistrer
                                        </button>
                                    </li>
                                    <li>
                                        <a href="{{ domain }}/contenus" class="fr-btn fr-icon-close-circle-line fr-btn--secondary">
                                            Annuler
                                        </a>
                                    </li>
                                </ul>
                            </div>
                            <div class="fr-col fr-col-6">
                                {% if content is not null %}
                                    <ul class="fr-btns-group fr-btns-group--md fr-btns-group--inline-lg fr-btns-group--icon-left right">
                                        <li>
                                            <button class="fr-btn fr-icon-send-plane-line" id="save-and-publish-content">
                                                Publier
                                            </button>
                                        </li>
                                    </ul>
                                {% endif %}
                            </div>
                        </div>
                    </form>
                </div>
            </section>
        </div>
    </div>
</div>

{% endautoescape %}
{% endblock %}

{% block script %}
{% autoescape %}
    <script src="/assets/tinymce/tinymce.min.js"></script>
    <script src="/assets/tinymce-i18n/langs5/fr_FR.js"></script>
    <script type="text/javascript">

        var csrfName = '{{ csrf.name }}';
        var csrfValue = '{{ csrf.value }}';

        tinymce.init({
            selector: 'textarea#content-text',
            height: 300,
            menubar: false,
            branding: false,
            language: 'fr_FR',
            plugins: 'preview searchreplace autolink directionality code visualblocks visualchars fullscreen table nonbreaking insertdatetime advlist lists wordcount charmap link',
            toolbar: 'undo redo | bold italic underline strikethrough formatselect | alignleft aligncenter alignright alignjustify | numlist bullist | link',
            importcss_append: true,
            quickbars_selection_toolbar: 'bold italic | h2 h3 blockquote quicktable'
        });

        document.querySelectorAll('.viewMedia').forEach(function(element) {
            element.addEventListener('click', function () {
                window.open(this.getAttribute('data-url'), '_blank');
            });
        });

        /** Hides "save and publish button" if none of channel checkboxes are checked */
        const handleSaveAndPublishButtonVisibility = () => {
            const hasChannelCheckboxesChecked = Boolean(document.querySelectorAll('[name="content-channel[]"]:checked').length);
            const saveAndPublishButton = document.getElementById('save-and-publish-content');
            if (saveAndPublishButton) {
                saveAndPublishButton.style.visibility = hasChannelCheckboxesChecked ? 'visible' : 'hidden';
            }
        }

        $(document).ready(function () {
            document.querySelectorAll('[name="content-channel[]"]').forEach(checkbox => checkbox.addEventListener(
                'change',
                handleSaveAndPublishButtonVisibility
            ));
            handleSaveAndPublishButtonVisibility();

            $('button#save-and-publish-content').on('click', function (e) {
                e.preventDefault();
                e.stopPropagation();
                const form = $(this).parents('form:first');
                form.attr('action', '/action/save-and-publish/content');
                form[0].requestSubmit(e.target);
            });
        });

    </script>

    <script type="text/javascript" src="/assets/dm-file-uploader/dist/js/jquery.dm-uploader.min.js"></script>
    <script type="text/html" id="files-template">
        <li class="media fr-grid-row fr-grid-row--middle fr-grid-row--center fr-grid-row--gutters">
            <input type="hidden" class="uploaded-input-filename" name="uploaded-files[%%fileid%%][filename]" />
            <input type="hidden" class="fileids" name="file_ids[]" value="%%fileid%%" />
            <div class="fr-col">
                <p class="fr-mb-2v"><strong class="uploaded-filename">%%filename%%</strong>
                    <br>
                    Statut : <span class="text-muted"
                        title="Supprimer">En attente</span></p>

                <div class="progress fr-mb-2v">
                    <div class="progress-bar progress-bar-striped progress-bar-animated bg-primary"
                        role="progressbar" style="width: 0%" aria-valuenow="0"
                        aria-valuemin="0" aria-valuemax="100">
                    </div>
                </div>
                <div class="form-group">
                    <label for="description">Description du document</label>
                    <textarea class="form-control form-control-sm"
                        id="file-description-%%fileid%%" name="uploaded-files[%%fileid%%][description]" rows="2" maxlength="250"></textarea>
                    <div class="invalid-feedback text-left">Veuillez saisir une
                        description pour ce document.
                    </div>
                </div>
                <hr/>
            </div>

        </li>
    </script>
    <script type="text/javascript">
        Multicanal.initDmUploader('#drag-and-drop-zone', '#drag-and-drop-messages');
    </script>
{% endautoescape %}
{% endblock %}
